config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  resources :people
  resources :processes do
    resources :phases, only: [:new, :create]
  end

  root to: 'home#index'
end

app/controllers/processes_controller.rb
class ProcessesController < ApplicationController
  before_action :load_people, only: [:new, :edit, :update, :create]
  before_action :set_process, only: [:show, :edit, :update]

  respond_to :html, :docx

  def index
    collection
    respond_with @processes
  end

  def new
    @process = McomProcess.new
    @process.phases.new
    find_and_set_author
  end

  def show
    # For some reason, respond_with it doesnt work
    # So use the old and ugly, respond_to
    respond_to do |format|
      format.docx do
        filename = "#{@process.author.name}-#{@process.description}.docx"
        render docx: 'show', filename: filename
      end
      format.html { render :show }
    end
  end

  def edit
  end

  def create
    @process = CreateProcess.create process_params
    respond_with @process, location: -> { process_path(@process) }
  end

  def update
    UpdateProcess.update(@process, process_params)
    respond_with @process, location: -> { process_path(@process) }
  end

  private

  def collection
    @filters = filter_params
    process_filter = AppFilters::Process.new(@filters)

    @processes = process_filter.filter
    @processes = @processes.page(params[:page])
  end

  def set_process
    @process = McomProcess.find(params[:id])
  end

  def load_people
    @physical = PhysicalPerson.all
    @legal = LegalPerson.all
    @people = @physical + @legal
  end

  def find_and_set_author
    return unless params[:author]
    id, type = params[:author].split('-')
    author = find_person(id, type)
    return unless author
    @process.author = author
  end

  def find_person(id, type)
    case type
    when 'physical' then PhysicalPerson.find(id)
    when 'legal' then LegalPerson.find(id)
    end
  end

  def process_params
    params.require(:mcom_process).permit(:description, :author_id, :defendant_id,
                                         :start_date, :end_date,
                                         phases_attributes: [:id, :description, :phase_date, :resume, :_destroy],
                                         pendencies_attributes: [:id, :description, :done, :_destroy])
  end

  def filter_params
    return {} unless params[:filters].present?
    params.require(:filters).permit(:description, :start_date, :end_date)
  end
end

app/helpers/processes_helper.rb
module ProcessesHelper
  def people_for_select(people)
    people.collect { |p| [p.name, p.id_to_select] }
  end
end

app/views/processes/_filters.html.haml
.panel.panel-default
  .panel-heading
    %h3.panel-title
      = fa_icon :filter, text: 'Filtros', class: 'fa-fw'

  .panel-body
    %form.form-horizontal
      .form-group
        %label.col-sm-2.control-label Pesquisar
        .col-sm-10
          %input.form-control{ type: 'text', name: 'filters[description]', value: @filters[:description], placeholder: 'Filtrar processos por descrição' }


      .form-group
        %label.col-sm-2.control-label De
        .col-sm-4
          %input.date.form-control{ type: 'text', name: 'filters[start_date]', value: @filters[:start_date] }

        %label.col-sm-2.control-label Até
        .col-sm-4
          %input.date.form-control{ type: 'text', name: 'filters[end_date]', value: @filters[:end_date] }

      %button.btn.btn-success.pull-right{ type: 'submit' }
        = fa_icon 'angle-double-right', text: 'Filtrar', right: true, class: 'fa-fw'

      - unless @filters.empty?
        = link_to processes_path, class: 'btn btn-default' do
          = fa_icon :times, text: 'Limpar filtros', class: 'fa-fw'

app/views/processes/_form.html.haml
.row
  .col-sm-12
    = render 'shared/error_messages', model: @process


.row
  .col-sm-12
    - unless @process.new_record?
      .row
        .col-sm-6
          .form-group
            = f.label(:author_id, nil, class: 'control-label')
            = f.hidden_field(:author_id, value: @process.author.id_to_select)
            %p.form-control-static
              = fa_icon @process.author.class.icon, text: @process.author.name
        .col-sm-6
          .form-group
            = f.label(:defendant_id, nil, class: 'control-label')
            = f.hidden_field(:defendant_id, value: @process.defendant.id_to_select)
            %p.form-control-static
              = fa_icon @process.author.class.icon, text: @process.defendant.name


    = simple_text f, :description
    - if @process.new_record?
      .form-group
        = f.label(:author_id, nil, class: 'control-label')
        = f.select :author_id, people_for_select(@people), { include_blank: true, selected: @process.author.try(:id_to_select) }, class: 'form-control'
      .form-group
        = f.label(:defendant_id, nil, class: 'control-label')
        = f.select :defendant_id, people_for_select(@people), { include_blank: true, selected: @process.defendant.try(:id_to_select) }, class: 'form-control'


.row
  .col-sm-6
    = simple_date f, :start_date
  .col-sm-6
    = simple_date f, :end_date

.row.wow-padt-top
  .col-sm-12
    %h4= model_with_icon Pendency, :plural
    %hr.legend
    .pendencies
      = f.fields_for :pendencies do |pendency|
        = render 'pendency_fields', f: pendency

  .col-sm-12.padt-top
    = link_to_add_association f, :pendencies, partial: 'pendency_fields', class: 'btn btn-info btn-block'


- if @process.new_record?
  .row.wow-padt-top
    .col-sm-12
      %h4= model_with_icon Phase, :plural
      %hr.legend
      .phases
        = f.fields_for :phases do |phase|
          = render 'phase_fields', f: phase
        .padt-top
          = link_to_add_association f, :phases, partial: 'phase_fields', class: 'btn btn-info btn-block'

.row
  .col-sm-12.text-right
    %hr
    = simple_submit f, :save, icon: :check

app/views/processes/_pendency_fields.html.haml
.nested-fields
  .col-xs-12.col-sm-4.col-lg-3
    = link_to_remove_association f, class: 'pull-right' do
      = fa_icon :times

    = simple_text f, :description
    = simple_checkbox f, :done

app/views/processes/_phase_fields.html.haml
.nested-fields
  .row
    .col-xs-12
      = link_to_remove_association f, class: 'pull-right' do
        = fa_icon :times
  .row
    .col-xs-12
      = simple_text f, :description
      = simple_date f, :phase_date
      = simple_area f, :resume, rows: 10
      %hr

app/views/processes/edit.html.haml
.page-header
  %h3= fa_icon McomProcess.icon, text: 'Editando processo'

= form_for @process, url: process_path(@process) do |f|
  = render 'form', f: f

app/views/processes/index.html.haml
.page-header
  .row
    .col-xs-7
      %h3= fa_icon McomProcess.icon, text: McomProcess.model_name.human(count: 2)
    .col-xs-5.h3.text-right
      = button_to_add new_process_path

.row
  .col-sm-12
    = render 'filters'

  .col-sm-12.wow-padt-top
    %table.table.table-striped.table-hover
      %thead
        %tr
          %th
          %th.text-center= McomProcess.human_attribute_name(:description)
          %th.text-center= McomProcess.human_attribute_name(:start_date)
          %th.text-center= McomProcess.human_attribute_name(:author)
          %th.text-center= McomProcess.human_attribute_name(:defendant)
          %th
      %tbody
        - @processes.each do |process|
          %tr
            %td
            %td
              = link_to process_path(process) do
                = process.description.truncate(20)
            %td.text-center= I18n.l process.start_date
            %td= process.author.name
            %td= process.defendant.name
            %td.text-right
              .btn-group
                = button_to_show process_path(process), label: nil

.text-center
  = paginate @processes

app/views/processes/new.html.haml
.page-header
  %h3= fa_icon McomProcess.icon, text: 'Novo processo'


= form_for @process, url: processes_path do |f|
  = render 'form', f: f

app/views/processes/show.docx.haml
- start_date = I18n.l(@process.start_date, format: :long)
- end_date = I18n.l(@process.end_date, format: :long) if @process.end_date

%h1.h.center= @process.description
%b
  - unless @process.end_date.present?
    = start_date
  - else
    = "#{start_date} até #{end_date}"

%h4
  %b= McomProcess.human_attribute_name(:author)
= render 'processes/docx/person', person: @process.author

%h4
  %b= McomProcess.human_attribute_name(:defendant)
= render 'processes/docx/person', person: @process.defendant

= render 'processes/docx/phases'

app/views/processes/show.html.haml
.page-header
  .row
    .col-xs-7
      %h3= fa_icon McomProcess.icon, text: @process.description
    .col-xs-5.h3.text-right
      .btn-group
        = link_to process_path(@process, format: :docx), class: 'btn btn-info' do
          = fa_icon :check, text: 'Exportar processo'

        = button_to_edit edit_process_path(@process)
.row
  .col-sm-8
    %h4= fa_icon :info, text: 'Informações'
    %hr.legend
    %dl.dl-horizontal
      = show_attr_info @process, :description
      = show_attr_info @process, :start_date, format: :long
      = show_attr_info @process, :end_date, format: :long
      = show_attr_info @process, :author
      = show_attr_info @process, :defendant
  .col-sm-4
    %h4= model_with_icon Pendency, :plural
    %hr.legend
    %ul
      - @process.pendencies.each do |pendency|
        %li
          - if pendency.done?
            %s= pendency.description
          - else
            = pendency.description

.row.wow-padt-top
  .col-sm-12
    .row
      .col-xs-8
        %h4= model_with_icon Phase, :plural
      .col-xs-4.text-right
        = button_to_add new_process_phase_path(@process), label: 'Adicionar fase'
    %hr.legend

    - @process.phases.each do |phase|
      %h4
        = l phase.phase_date, format: :long
        = ' - '
        = phase.description

      %p.resume-phase
        = phase.resume
      %hr